import { BasicColumn, FormSchema } from '/@/components/Table';
import { getTown, getHylb, dict } from '/@/api/common/api';
import { convertTreeData } from '/@/utils/modifFiled';
import { ref } from 'vue';

export const useSuspectsData = () => {
  const suspects = ref([]);
  // 获取行业分类
  const getIsSuspect = async () => {
    suspects.value = await dict({ key: 'dk_hyfl' });
  };
  getIsSuspect();
  return { data: suspects };
};

export const useCategoryData = () => {
  let allCategory = [];
  const treeData = ref([]);
  // 获取行业类别
  const getData = async () => {
    allCategory = await getHylb({});
    allCategory = convertTreeData(allCategory); // 只显示前2级
    allCategory.forEach((item) => {
      item.disabled = true; // 第1层级不能选中
    });
    treeData.value = allCategory;
  };
  getData();
  // 改变行业分类
  function changeIsSuspect(v) {
    if (v == 1) {
      // 只显示42号类
      treeData.value = allCategory.filter((item) => item['is42']);
    } else {
      treeData.value = allCategory;
    }
  }
  return { data: treeData, changeIsSuspect };
};

export const columns: BasicColumn[] = [
  {
    title: '地块名称',
    dataIndex: 'wrdkmc',
  },
  {
    title: '地块编码',
    dataIndex: 'wrdkbm',
  },
  {
    title: '市',
    dataIndex: 'cityName',
  },
  {
    title: '县',
    dataIndex: 'countryName',
  },
  {
    title: '行业类别',
    dataIndex: 'hylb',
  },
  {
    title: '政策依据',
    dataIndex: 'faliYiju',
  },
  {
    title: '地块类型',
    dataIndex: 'dklx',
  },
  {
    title: '退出状态',
    dataIndex: 'tcdw',
    customRender: ({ record }: any) => {
      if (record.tcwr == '0') {
         return '未退出'
      } else if (record.tcwr == '1')
        return '已退出'
      else if(record.tcwr == '2') return '申请退出'
    },
  },
  {
    title: '更新时间',
    dataIndex: 'createTsamp',
  },
  {
    title: '登录帐号',
    dataIndex: 'userId',
  },
];

// T1：填报中 DSL：待受理 T2：待评审 SH：评审通过 SHBTG：评审不通过 SHHDWS：评审后待完善 BPS：不评审 DKDTC：地块待退出 DKYTC：地块已退出
export const searchFormSchema: FormSchema[] = [
  {
    label: '行政区(市)',
    field: 'cityCode',
    component: 'ApiSelect',
    componentProps: ({ formModel, formActionType }) => {
      return {
        api: getTown,
        params: 440000, // 行政区划编码
        labelField: 'name',
        valueField: 'id',
        onChange: (val: any) => {
          const { updateSchema } = formActionType;
          formModel.countryCode = undefined;
          if (val) {
            updateSchema({
              field: 'countryCode',
              componentProps: {
                api: getTown,
                params: val,
              },
            });
          } else {
            updateSchema({
              field: 'countryCode',
              componentProps: {
                api: undefined,
              },
            });
          }
        },
      };
    },
  },
  {
    label: '区县',
    field: 'countryCode',
    component: 'ApiSelect',
    componentProps: {
      labelField: 'name',
      valueField: 'id',
    },
  },
  {
    label: '行业分类',
    field: 'isSuspect',
    component: 'ApiSelect',
    slot: 'suspect',
  },
  {
    label: '行业类别',
    field: 'hylb',
    component: 'TreeSelect',
    slot: 'category',
  },
  {
    label: '地块类型',
    field: 'dklx',
    component: 'JSearchSelect',
    componentProps: {
      dict: 'dk_dklx',
    },
  },
  // {
  //   label: '地块名称',
  //   field: 'wrdkmc',
  //   component: 'Input',
  // },
  {
    label: '地块名称或者编码',
    field: 'wrdkbm',
    component: 'Input',
  },
  {
    label: '登录帐号',
    field: 'userId',
    component: 'Input',
  },
];

// 方案列表
export const Fxcolumns: BasicColumn[] = [
  {
    title: '风险管控效果评估标题',
    dataIndex: 'bt',
  },
  {
    title: '编制单位',
    dataIndex: 'bzdw',

  },
  {
    title: '填报状态',
    dataIndex: 'tbzt',
  },
  {
    title: '更新日期',
    dataIndex: 'tsamp',
  },
  {
    title: '退回状态',
    dataIndex: 'wrdkmc',
  },
];

// 退回
export const BackFormSchema: FormSchema[] = [
  {
    label: '污染地块id',
    field: 'wrdkid',
    component: 'ApiSelect',
    show: false,
  },
  {
    label: '阶段编码',
    field: 'scjdbm',
    component: 'ApiSelect',
    show: false,
  },
  {
    label: '填报阶段编码',
    field: 'tbjdbm',
    component: 'ApiSelect',
    show: false,
  },

  {
    label: '退回意见',
    field: 'clyj',
    component: 'Input',
    required: true
  },
  {
    label: '文件',
    field: 'clyjfj',
    component: 'JUpload',
    required: true,
    componentProps: {
      showUploadList: false,
      fileName: '退回文件',
    }
  },
]